####2017-09-27 Agilent Rabbit genome array 4*44k
####Data: A(6 samples), C(6 samples), O(4 samples), Nomalization data
####Group_list: A-c, A-o, C-O
rm(list=ls())
setwd("D:/R/Agilent44k_Rawdata/20171010_DEGs")
library(GEOquery)
library(limma) 
library(Biobase)
exprSet<-read.csv("Agilent44k.csv",header = TRUE,sep=",",row.names = 1)
#Expressionset
head(exprSet)
probeset <- rownames(exprSet)##
head(probeset)
probe2symbol<-read.table("GPL7083_2.txt",header = TRUE,sep="\t")
head(probe2symbol)
symbol=probe2symbol[match(probeset,probe2symbol[,1]),4]
head(symbol)
symbol= as.character(symbol)
a=cbind(symbol,exprSet)
head(a)
# remove the duplicated probeset 
rmDupID <-function(a=matrix(c(1,1:5,2,2:6,2,3:7),ncol=6)){
  exprSet=a[,-1]
  rowMeans=apply(exprSet,1,function(x) mean(as.numeric(x),na.rm=T))
  a=a[order(rowMeans,decreasing=T),]
  exprSet=a[!duplicated(a[,1]),]
  #
  exprSet=exprSet[!is.na(exprSet[,1]),]
  rownames(exprSet)=exprSet[,1]
  exprSet=exprSet[,-1]
  return(exprSet)
}
exprSet=rmDupID(a)
head(exprSet)
exprSet[1:4,1:4]
boxplot(exprSet,las=2)
write.csv(exprSet,"probe_exprs01.csv")

####
####limma
eset=exprSet
condition=factor(c(rep("A",6),rep("C",6),rep("O",4)))
condition
design<-model.matrix(~-1+condition)
design
colnames(design)<-c("A","C","O")
contrast.matrix<-makeContrasts(A-C,A-O,C-O,levels = design)
contrast.matrix
fit <- lmFit(eset, design)
fit1<-contrasts.fit(fit,contrast.matrix)
fit2<-eBayes(fit1)
##
###
dif1<-topTable(fit2,coef=1,n=nrow(fit2),adjust="BH")
dif2<-topTable(fit2,coef=2,n=nrow(fit2),adjust="BH")
dif3<-topTable(fit2,coef=3,n=nrow(fit2),adjust="BH")
write.csv(dif1,"difA_C.csv")
write.csv(dif2,"difA_O.csv")
write.csv(dif2,"difC_O.csv")

###
#
dif1_lfc2<-topTable(fit2,coef=1,n=nrow(fit2),lfc=log2(2),adjust="BH")
dif2_lfc2<-topTable(fit2,coef=2,n=nrow(fit2),lfc=log2(2),adjust="BH")
dif3_lfc2<-topTable(fit2,coef=3,n=nrow(fit2),lfc=log2(2),adjust="BH")

##
DEG_1<-dif1_lfc2[dif1_lfc2[,"adj.P.Val"]<0.05,]
DEG_2<-dif2_lfc2[dif2_lfc2[,"adj.P.Val"]<0.05,]
DEG_3<-dif3_lfc2[dif3_lfc2[,"adj.P.Val"]<0.05,]

##
write.csv(DEG_1,"DEGs_A_C.csv")
write.csv(DEG_2,"DEGs_A_O.csv")
write.csv(DEG_3,"DEGs_C_O.csv")

##############################################################
